// SLDWORKS_EXTRACTBITMAPIMPL.H : Declaration of the TSldWorks_ExtractBitmapImpl

#ifndef SldWorks_ExtractBitmapImplH
#define SldWorks_ExtractBitmapImplH

#include "SldWorks_ExtractBitmap_TLB.h"


/////////////////////////////////////////////////////////////////////////////
// TSldWorks_ExtractBitmapImpl     Implements ISldWorks_ExtractBitmap, default interface of SldWorks_ExtractBitmap
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Event Support  : FALSE
// Default ProgID : Project1.SldWorks_ExtractBitmap
// Description    : Extract bitmap preview from SolidWorks file
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TSldWorks_ExtractBitmapImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TSldWorks_ExtractBitmapImpl, &CLSID_SldWorks_ExtractBitmap>,
  public IDispatchImpl<ISldWorks_ExtractBitmap, &IID_ISldWorks_ExtractBitmap, &LIBID_SldWorks_ExtractBitmap>
{
public:
  TSldWorks_ExtractBitmapImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("SldWorks_ExtractBitmap.SldWorks_ExtractBitmap");
  DECLARE_DESCRIPTION("Extract bitmap preview from SolidWorks file");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TSldWorks_ExtractBitmapImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TSldWorks_ExtractBitmapImpl)
  COM_INTERFACE_ENTRY(ISldWorks_ExtractBitmap)
  COM_INTERFACE_ENTRY2(IDispatch, ISldWorks_ExtractBitmap)
END_COM_MAP()

// ISldWorks_ExtractBitmap
public:
 
  STDMETHOD(ExtractBitmap(BSTR SolidWorksFilename, BSTR BitmapFilename,
      long Width, long Height, long* Error));
};

#endif //SldWorks_ExtractBitmapImplH
